[![][travis img]][travis]
[![][appveyor img]][appveyor]
[![][teamcity img]][teamcity]
[![][coverage img]][coverage]

[![][mavenbadge img]][mavenbadge]
[![][versioneye img]][versioneye]
[![][sonar img]][sonar]

Members chat: [![][gitter img]][gitter]
Contributors chat: [![https://gitter.im/checkstyle/checkstyle](https://badges.gitter.im/Join%20Chat.svg)](https://gitter.im/checkstyle/checkstyle?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)

![](https://raw.githubusercontent.com/checkstyle/resources/master/img/checkstyle-logos/checkstyle-logo-260x99.png)

Checkstyle is a tool for
checking Java source code for adherence to a Code Standard or set of validation rules (best practices).

The latest release version can be found at [SourceForge downloads](http://sourceforge.net/projects/checkstyle/files/checkstyle/) or at [Maven repo](http://repo1.maven.org/maven2/com/puppycrawl/tools/checkstyle/).

Each-commit builds of maven artifacts can be found at [Maven Snapshot repository](https://oss.sonatype.org/content/repositories/snapshots/com/puppycrawl/tools/checkstyle/).

Documentation is available in HTML format, see http://checkstyle.sourceforge.net/checks.html.

Continuous integration and Quality reports
======================
Travis (Linux & MacOS build): [![][travis img]][travis]
Appveyor (Windows build): [![][appveyor img]][appveyor]

Quality reports: http://checkstyle.sourceforge.net/project-reports.html

JavaScript, CSS and Java source file analysis on Codacy: [![][codacy img]][codacy]

Feedback/Support
========

Please send any feedback to https://groups.google.com/forum/?hl=en#!forum/checkstyle

Questions and Answers from community: [![][stackoverflow img]][stackoverflow]

Bugs and Feature requests: https://github.com/checkstyle/checkstyle/issues

Licensing
=========

[![][license img]][license]

This software is licensed under the terms in the file named "LICENSE" in this
directory.

The software uses the ANTLR package (http://www.antlr.org). Its license terms
are in the file named "RIGHTS.antlr" in this directory.

This product includes software developed by
The Apache Software Foundation (http://www.apache.org/).

The software uses the Cli, Logging and Beanutils packages from the
Apache Commons project (http://commons.apache.org/). The license terms
of these packages are in the file named "LICENSE.apache20" in this
directory.

The software uses the Google Guava Libraries
(https://code.google.com/p/guava-libraries/). The license terms of
these packages are in the file named "LICENSE.apache20" in this
directory.

[travis]:https://travis-ci.org/checkstyle/checkstyle/builds
[travis img]:https://secure.travis-ci.org/checkstyle/checkstyle.png

[appveyor]:https://ci.appveyor.com/project/checkstyle/checkstyle/history
[appveyor img]:https://ci.appveyor.com/api/projects/status/rw6bw3dl9kph6ucc?svg=true

[sonar]:http://nemo.sonarqube.org/dashboard/index/com.puppycrawl.tools:checkstyle
[sonar img]:https://img.shields.io/sonar/http/nemo.sonarqube.org/com.puppycrawl.tools:checkstyle/tech_debt.svg?label=Sonarqube%20tech%20debt

[codacy]:https://www.codacy.com/app/checkstyle/checkstyle
[codacy img]:https://api.codacy.com/project/badge/3adf12d434314ba8b38277ea46d3c44b

[coverage]:http://codecov.io/github/checkstyle/checkstyle?branch=master
[coverage img]:http://codecov.io/github/checkstyle/checkstyle/coverage.svg?branch=master

[license]:LICENSE
[license img]:https://img.shields.io/badge/license-GNU%20LGPL%20v2.1-blue.svg

[mavenbadge]:http://search.maven.org/#search|gav|1|g%3A%22com.puppycrawl.tools%22%20AND%20a%3A%22checkstyle%22
[mavenbadge img]:https://maven-badges.herokuapp.com/maven-central/com.puppycrawl.tools/checkstyle/badge.svg

[versioneye]:https://www.versioneye.com/user/projects/5504ca834a1064774400049a
[versioneye img]:https://www.versioneye.com/user/projects/5504ca834a1064774400049a/badge.svg

[gitter]:https://gitter.im/checkstyle
[gitter img]:http://img.shields.io/badge/gitter-JOIN%20CHAT-blue.svg

[gitterpublic]:https://gitter.im/checkstyle/checkstyle
[gitterpublic img]:https://badges.gitter.im/Join%20Chat.svg)

[stackoverflow]:http://stackoverflow.com/questions/tagged/checkstyle
[stackoverflow img]:https://img.shields.io/badge/stackoverflow-CHECKSTYLE-blue.svg

[teamcity]:https://teamcity.jetbrains.com/viewType.html?buildTypeId=Checkstyle_IdeaInspectionsMaster
[teamcity img]:https://img.shields.io/teamcity/http/teamcity.jetbrains.com/s/Checkstyle_IdeaInspectionsMaster.svg?label=TeamCity%20inspections

